/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.domdemo;

import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class DOMDemo {

    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, TransformerConfigurationException, TransformerException {

        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();

        Document doc = db.parse("people.xml");

        Element people = doc.getDocumentElement();

        // iterate through all child elements
        NodeList nl = people.getChildNodes();

        for (int i = 0; i < nl.getLength(); i++) {
            Node node = nl.item(i);
            //System.out.println(node);
        }

        NodeList persons = people.getElementsByTagName("person");
        Element libor;

        for (int i = 0; i < persons.getLength(); i++) {
            Element person = (Element) persons.item(i);

            String id = person.getAttribute("id");

            if ("libor".equals(id)) {
                // now we have the "libor"
                libor = person;
                
                Node peopleElement = person.getParentNode();
                // removes from the original place
                peopleElement.removeChild(libor);
                // adds to the end (as the last child of people)
                peopleElement.appendChild(libor);
                break;
                
            } 
        }
        
        // just to print out the resulting document as text
        // it seems complicated, due to the JAXP 
        // it would be much simpler with dom4j and similar APIs
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(System.out);
        // Provedeme transformaci
        transformer.transform(source, result);
    }
}
